--[[
  ロボカップ用のLuaスクリプト
  bhv_basic_moveをLuaで実装している
]]

--require("luaLib/lua_init")
dofile("luaLib/lua_init.lua")
--require("luaLib/Move/Tackle")
dofile("luaLib/Move/Tackle.lua")
--インスタンス生成
ball_dist = 18.0	--探索をゆるすボールの距離
agentMove = BasicMove()

intercept_cycle = 3 --インターセプトのサイクル

--インターセプトできるかどうか(cycle : 追跡サイクルの最大値)
function is_intercept(cycle)
   --サイクルの設定

   local self_min = selfReachCycle()
   local mate_min = teammateReachCycle()
   local opp_min = oppReachCycle()

   if((existKickableMate()==false) and 
	(self_min <= cycle or (self_min <= mate_min
		and self_min <= opp_min + cycle)
	)) then
	return true
   end

   return false
end

--ボールに焦点を合わせる(dist : ボールまでの距離)
function turn_To_ball(dist)
   if((existKickableOpponent() == true) and (getBallDist() < dist)) then
	agentMove:neck_turn_to_Ball() --ボールに首を向ける
   else
	agentMove:neck_turn_to_BallOrScan() --ボールに首を向けるかスキャンする
   end
end

--ベーシックムーブのメイン(Move)
function move_main()
   --print("Luabind:basic_move")

   ret = tackle_main()
   if (ret == true) then
	return 1
   end

   --If agent can intercept, try intercept.
   ret = is_intercept(intercept_cycle)
   if (ret == true) then
	agentMove:try_intercept()
	return 1
   end

  local ball_dist_thr = getBallDist() * 0.1 --ボール距離の限界値

   --ボールがプレイヤーと接触してるなら距離を0.1とする
   if (ball_dist_thr < 1.0) then	
	ball_dist_thr = 1.0
   end

   --ボールの場所まで移動させる
   agentMove:body_go_to_ball(ball_dist_thr)

   --ボールに焦点を合わせる
   turn_To_ball(ball_dist)
   
   return 1
end

--ムーブを設定する
function basic_move(bdist)
	ball_dist = bdist
end
