--[[
  ロボカップ用のLuaスクリプト
  view_tacticalをLuaで実装している
]]
--require("luaLib/lua_init")
dofile("luaLib/lua_init.lua")

local view_pat = "default"

-- 視野変更
local function ChangeView(vtype)
   local view_type = 0
   if (vtype == "NARROW") then
	view_type = 1
   elseif (vtype == "NORMAL") then
	view_type = 2
   elseif (vtype == "WIDE") then
	view_type = 3
   end

   return doView(view_type)
end

-- 視野範囲
local function ViewWidth(vtype)
   local view_type = 0
   if (vtype == "NARROW") then
	view_type = 1
   elseif (vtype == "NORMAL") then
	view_type = 2
   elseif (vtype == "WIDE") then
	view_type = 3
   end

   return getViewWidth(view_type)
end

function isGoalieView()

   -- キーパーはボールを持っていないときに視野変更
   if ((getSelfNum() == 1) 
	and (not isKickable())) then
	-- キーパーの視野範囲にボールがあるかどうか
   	if (basicView:GoalieValid()) then
	   ball_angle = getBallAngleAbs()
	   angle_diff = ball_angle - maxNeckAngle()
	   if (angle_diff > ViewWidth("NORMAL") * 0.5 - 3.0) then
		return ChangeView("WIDE")
	   elseif (angle_diff > ViewWidth("NARROW") * 0.5 - 3.0) then
		return ChangeView("NORMAL")
	   end
	end
   end

   return false
end

function defaultView()
    -- デフォルトのView設定
    ball_dist = getBallDist()
    if (ball_dist > 40.0) then
	return ChangeView("WIDE")
    end

    if(ball_dist > 20.0) then
	return ChangeView("NORMAL")
    end

    if(ball_dist > 10.0) then
        ball_angle = getBallAngleAbs()
	if (ball_angle > 120.0) then
	   return ChangeView("WIDE")
	end
    end

    return false
end

function view_main()
    local view = view_pat
   view_pat = "default" -- 設定を戻す
   if (isGoalieView()) then
	return true
   end
   -- ボールの距離に応じて変更
   if (view == "default" and defaultView()) then
	 return true
   elseif (ChangeView(view)) then
	 return true
   end

   teammate_dist = 1000
   opp_dist = 1000
   if (not teamMateBallEmpty()) then
	teammate_dist = topMateBallDist()
   end

   if (not oppBallEmpty()) then
	opp_dist = oppBallDist()
   end

   if ((getSelfNum() ~= 1) and
	(teammate_dist > 5.0) and
	(opp_dist > 5.0) and
	(ball_dist > 10.0)) then
	return ChangeView("NORMAL")
   end

   --ビューの同期
   return View_Synch()
end

--ビューの設定
function View(vtype)
   view_pat = vtype
end
