/** \file timer_function.cpp
*   \brief タイマーに関するバインド用ファイル
*   \auther Shun.E
*/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>

#include <rcsc/action/basic_actions.h>
#include <rcsc/player/player_agent.h>
#include <rcsc/player/debug_client.h>

#include <rcsc/common/audio_memory.h>
#include <rcsc/common/logger.h>
#include <rcsc/common/server_param.h>

#include "timer_function.h"
#include "izk_main.h"

using namespace luabind;
using namespace rcsc;

/** \fn l_getTimerCycle
*   \brief 現在のサイクルを取得
*   \return 現在のサイクル
*/
int
l_getTimeCycle()
{
    const WorldModel & tok_wm = izk_agent->world();	// WorldModelの設定	
    return tok_wm.time().cycle();
}

/** \fn l_getTimeStopped
*   \brief 停止サイクルを取得
*   \return 停止サイクル
*/
int
l_getTimeStopped()
{
    const WorldModel & tok_wm = izk_agent->world();	// WorldModelの設定	
    return tok_wm.time().stopped();
}

/** \fn openFile
*   \brief Luaファイルを開く
*/
void
TimerFunction::openFile()
{

}


/** \fn bindFunc
*   \brief 関数のバインドを行う
*/
void
TimerFunction::bindFunc()
{
    // 関数やクラスを登録
    module(Luas)
    [
        def("getTimeCycle", &l_getTimeCycle),
        def("getTimeStopped", &l_getTimeStopped)
    ];
}
